"""
Very simple calculator

using pyparsing
"""

from pyparsing import oneOf, Word, nums, operatorPrecedence, opAssoc

number = Word(nums).setParseAction(lambda t: int(t[0]))

signop = oneOf('+ -')
plusop = oneOf('+ -')
multop = oneOf('* /')

expr = operatorPrecedence( number,
      [(signop, 1, opAssoc.RIGHT),
       (multop, 2, opAssoc.LEFT),
       (plusop, 2, opAssoc.LEFT),] 
      )

test = ["9 + 2 + 3",
      "9 + 2 *3",
      "-9 + 2 * 3",
      "(-9 + 2) * 3"
      ]

for t in test:
    for item in expr.parseString(t):
        print item



