import ply.lex, ply.yacc

tokens = ('WORD', 'COMMA', 'STRING')

t_WORD = r'[A-Za-z]+'
t_STRING = r'\".*?\"'
t_COMMA = r','

t_ignore = ' '

def t_error(t):
    raise ValueError("Illegal Character '%s'" % t.value[0])


def p_expression(p):
    """
    expression : list
    """
    p[0] = p[1]

def p_list(p):
    """
    list : list COMMA list
         | WORD COMMA list
         | STRING COMMA list
         | STRING
         | WORD
    """
    if len(p) == 2:
        p[0] = [ p[1] ]
    else:
        p[0] = [ p[1] ] + p[3]

def p_error(p):
    raise ValueError("Illegal String '%s'" % p)


Lexer = ply.lex.lex()

Parser = ply.yacc.yacc()


sentence = ' "A, B", C, "D, E" '

print sentence
print 'split'

for item in sentence.split(','):
    print item

print
print 'Parser'

for item in Parser.parse(sentence):
    print item
