import ply.lex, ply.yacc
import time

tokens = ('WORD', 'COMMA', 'STRING')

t_WORD = r'[A-Za-z]+'
t_STRING = r'\".*?\"'
t_COMMA = r','

t_ignore = ' '

def t_error(t):
    raise ValueError("Illegal Character '%s'" % t.value[0])


def p_expression(p):
    """
    expression : list
    """
    p[0] = p[1]

def p_list(p):
    """
    list : list COMMA list
         | WORD COMMA list
         | STRING COMMA list
         | STRING
         | WORD
    """
    if len(p) == 2:
        p[0] = [ p[1] ]
    else:
        p[0] = [ p[1] ] + p[3]

def p_error(p):
    raise ValueError("Illegal String '%s'" % p)


Lexer = ply.lex.lex()

Parser = ply.yacc.yacc()


sentence = ' "A, B", C, "D, E" '


iter=5000
fStart = time.clock()

for j in range(iter):
    Parser.parse(sentence)

fTime = time.clock() - fStart

print 'iter %d, time %f, avg %f' % (iter, fTime, fTime/iter)
