from pyparsing import ZeroOrMore, OneOrMore, CharsNotIn, Suppress, Optional, \
      QuotedString, Word, alphas, nums, CaselessLiteral, Combine, Literal, Dict, \
      Group

comment = Group(Literal("#") + ZeroOrMore(CharsNotIn('\n')))

value = Word(alphas)|QuotedString('"')

viaClause = Group(Literal('via') + value)

protoClause = Group(Literal('proto') + value)

authClause = Group(Literal('auth') + value)

timeoutClause = Group(Literal('timeout') + Word(nums))

hereThere = Literal('here')|Literal('there')

userClause = Group (Literal('user') + value + Optional(hereThere)) + Group(Literal('is') + value + Optional(hereThere))

passClause = Group(Literal('pass') + value)

serverOption = viaClause|timeoutClause|protoClause

serverLine = Group(Literal('poll') + value) + ZeroOrMore(serverOption) 

userLine = userClause + passClause

fetchmail = Dict(OneOrMore((comment | userLine | serverLine)))

fetchmail.ignore(CaselessLiteral('has'))
fetchmail.ignore(CaselessLiteral('wants'))
fetchmail.ignore(CaselessLiteral('and'))
fetchmail.ignore(CaselessLiteral('with'))
fetchmail.ignore(CaselessLiteral('options'))


tests = [
      '# comment',
      '  poll host with proto "POP3" and via "host 2" options timeout 10',
      '     user z here is y there with pass "Lordy Me"'
      ]

for t in tests:
   print t
   res=fetchmail.parseString(t)
   for key in res.keys():
       print '%s => %s' % (key, res[key])

