import ply.lex, ply.yacc
import time


fStartTime = time.clock()

tokens = ('WORD', 'END')

t_END = r'\!'
t_WORD = r'[A-Za-z]+'

t_ignore = ' '

def t_error(t):
    raise ValueError("Illegal Character '%s'" % t.value[0])


def p_expression(p):
    """
    expression : WORD WORD END
    """
    p[0] = 'Word 1: %s,  Word 2: %s, Sentence End: %s' % ( p[1], p[2], p[3] ) 

def p_error(p):
    raise ValueError("Illegal String '%s'" % p)


Lexer = ply.lex.lex()

Parser = ply.yacc.yacc()

hello = 'Hello World!'

iter=10000

for j in range(iter):
    Parser.parse(hello)

fTime = time.clock() - fStartTime

print "%d iterations, %f total time, %f average time" % (iter, fTime, fTime/iter)
